﻿using Infragistics.Win.DataVisualization;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win.DataVisualization;
using Point = Infragistics.Win.DataVisualization.Point;

namespace CustomShapeMap
{
    public partial class Form1 : Form
    {
        public List<RouteColor> Route { get; set; }


        public Form1()
        {
            
            InitializeComponent();
            TestData data = new TestData();
            this.Load += Form1_Load;
            var series = new GeographicSymbolSeries()
            {
                LongitudeMemberPath = "Longitude",
                LatitudeMemberPath = "Latitude",
                MarkerType = MarkerType.Circle,
            };


            //series.DataSource = data;
            
            ultraGeographicMap1.Series.Add(series);
           
            
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            var shapeSeries = new GeographicShapeSeries()
            {
                ShapeMemberPath = "Points",
                Brush = new SolidColorBrush(Color.Red)
            };

            
            ultraGeographicMap1.Series.Add(shapeSeries);
            // create the route
            Route = new List<RouteColor>();
            Route.Add(new RouteColor { Color = Color.Green });
            Route.Add(new RouteColor { Color = Color.Yellow });
            Route.Add(new RouteColor { Color = Color.Red });

            var greenPoints = new List<IEnumerable<Point>>();
            greenPoints.Add(new List<Point> { new Point(-75.058594, 39.198205), new Point(-81.035156, 28.420391), new Point(-57.128906, 6.096860) });
            greenPoints.Add(new List<Point> { new Point(32.167969, -11.738302), new Point(45.175781, -20.179724) });

            var yellowPoints = new List<IEnumerable<Point>>();
            yellowPoints.Add(new List<Point> { new Point(-57.128906, 6.096860), new Point(-34.980469, -6.184246) });

            var redPoints = new List<IEnumerable<Point>>();
            redPoints.Add(new List<Point> { new Point(-34.980469, -6.184246), new Point(20.214844, -32.138409), new Point(32.167969, -11.738302) });

            Route[0].Points = greenPoints;
            Route[1].Points = yellowPoints;
            Route[2].Points = redPoints;

            shapeSeries.DataSource = Route;

        }

        public class RouteColor
        {
            public Color Color { get; set; }

            public IEnumerable<IEnumerable<Point>> Points { get; set; }
        }

        

        //private void PlotShape(List<Point> list)
        //{

        //    var series = new GeographicSymbolSeries()
        //    {
        //        LongitudeMemberPath = "X",
        //        LatitudeMemberPath = "Y",
        //        MarkerType = MarkerType.Circle,
        //    };
        //    var shapeSeries = new GeographicPolylineSeries()
        //    {
        //        ShapeMemberPath = "list",
        //        //MarkerType = MarkerType.Circle,
        //    };

        //    var brush = new SolidColorBrush();
        //    brush.Color = Color.WhiteSmoke;
        //    series.Brush = brush;
        //    series.MarkerBrush = brush;

        //    var outline = new SolidColorBrush();
        //    outline.Color = Color.FromArgb(21, 115, 255);
        //    series.MarkerOutline = outline;

        //    series.IsHighlightingEnabled = true;

        //    series.MouseOverEnabled = true;
        //    series.Thickness = 0.5;

        //    var brush2 = new SolidColorBrush();
        //    brush2.Color = Color.WhiteSmoke;
        //    shapeSeries.Brush = brush;
        //    //shapeSeries.MarkerBrush = brush;

        //    var outline2 = new SolidColorBrush();
        //    outline2.Color = Color.FromArgb(21, 115, 255);
        //    //shapeSeries.MarkerOutline = outline;

        //    shapeSeries.IsHighlightingEnabled = true;

        //    shapeSeries.MouseOverEnabled = true;
        //    shapeSeries.Thickness = 0.5;

        //    var geoLocations = new List<Infragistics.Win.DataVisualization.Point>();

        //    foreach (var point in list)
        //    {
        //        var infraPoint = new Infragistics.Win.DataVisualization.Point() { X = point.X, Y = point.Y };
        //        geoLocations.Add(infraPoint);
        //    }

        //    series.DataSource = geoLocations;
        //    shapeSeries.DataSource = geoLocations;
        //    this.ultraGeographicMap1.Series.Add(shapeSeries);
        //    this.ultraGeographicMap1.Series.Add(series);

        //}

        public class TestData
        : List<TestDataItem>
        {
            List<List<Point>> list = new List<List<Point>>();
            
              
            public TestData()
            {
                
                list.Add(new List<Point> { new Point(0, 20) });
                list.Add(new List<Point> { new Point(20, 0) });
                list.Add(new List<Point> { new Point(50, 20)});
                list.Add(new List<Point> { new Point(20, 50) });

                Add(new TestDataItem() { Label = "A", Latitude = 0, Longitude = 20, Shape = list});
                Add(new TestDataItem() { Label = "B", Latitude = 20, Longitude = 0, Shape = list});
                Add(new TestDataItem() { Label = "C", Latitude = 50, Longitude = 20, Shape = list });
                Add(new TestDataItem() { Label = "D", Latitude = 20, Longitude = 50, Shape = list });
            }


            public void GeneratePoints()
            {

            }
            
        }


        public class TestDataItem
            : INotifyPropertyChanged
        {
            private string _label;
            public string Label
            {
                get
                {
                    return _label;
                }
                set
                {
                    _label = value;
                    OnPropertyChanged("Label");
                }
            }

            private double _latitude;
            public double Latitude
            {
                get
                {
                    return _latitude;
                }
                set
                {
                    _latitude = value;
                    OnPropertyChanged("Latitude");
                }
            }

            private double _longitude;
            public double Longitude
            {
                get
                {
                    return _longitude;
                }
                set
                {
                    _longitude = value;
                    OnPropertyChanged("Longitude");
                }
            }

            private bool _isSelected;
            public bool IsSelected
            {
                get
                {
                    return _isSelected;
                }
                set
                {
                    _isSelected = value;
                    OnPropertyChanged("IsSelected");
                }
            }

            private List<List<Point>> _list;
            public List<List<Point>> Shape
            {
                get
                {
                    return _list;
                }
                set
                {
                    _list = value;
                    OnPropertyChanged("Points");
                }
            }

            protected void OnPropertyChanged(string propertyName)
            {
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
                }
            }

            public event PropertyChangedEventHandler PropertyChanged;
        }

        
    }
    }
